package com.datacloudsec.scan.cache;

import com.datacloudsec.scan.common.Constant;
import com.datacloudsec.utils.EntryResult;
import com.datacloudsec.utils.JsonUtil;
import com.google.common.collect.Multimap;
import java.io.File;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;
import org.apache.commons.io.FilenameUtils;

public class OffsetBlinePolicy {

   private Map config;
   private Map txtConfig;
   private Map fileExtension;
   private Set poliNames;
   private static long lastMdfTime;
   private static File confFile = new File(Constant.CONF_DIR, "offsetpolicy");
   private static OffsetBlinePolicy instance;


   public static synchronized OffsetBlinePolicy getInstance() throws Exception {
      if(instance == null) {
         instance = new OffsetBlinePolicy();
      }

      if(confFile.lastModified() != lastMdfTime) {
         instance.config = new HashMap();
         instance.txtConfig = new HashMap();
         instance.fileExtension = new HashMap();
         instance.poliNames = new HashSet();
         File[] var3;
         int var2 = (var3 = confFile.listFiles()).length;

         for(int var1 = 0; var1 < var2; ++var1) {
            File f = var3[var1];
            String baseName = FilenameUtils.getBaseName(f.getName());
            String extension = FilenameUtils.getExtension(f.getName());
            instance.poliNames.add(baseName);
            instance.fileExtension.put(baseName, extension);
            if("json".equalsIgnoreCase(extension)) {
               instance.config.put(baseName, EntryResult.parseMultiEntry((List)JsonUtil.MAPPER.readValue(f, List.class), "id", "shell"));
            } else if("txt".equalsIgnoreCase(extension)) {
               instance.txtConfig.put(baseName, f);
            }
         }

         lastMdfTime = confFile.lastModified();
      }

      return instance;
   }

   public static void main(String[] args) throws Exception {
      Iterator iter = ((Multimap)getInstance().getConfig().get("centos")).entries().iterator();

      while(iter.hasNext()) {
         Entry entry = (Entry)iter.next();
         System.out.println((String)entry.getKey() + ":" + entry.getValue());
      }

   }

   public Map getConfig() {
      return this.config;
   }

   public Map getTxtConfig() {
      return this.txtConfig;
   }

   public Map getFileExtension() {
      return this.fileExtension;
   }

   public Set getPoliNames() {
      return this.poliNames;
   }

   public static File getConfFile() {
      return confFile;
   }
}
